//
// Created by nicolas on 22/03/18.
//

#ifndef ESC_ESC_ENDPOINT_DISCOVERER_H
#define ESC_ESC_ENDPOINT_DISCOVERER_H

#include "utils/bool.h"

typedef struct st_ip_endpoint {
    char* host;
    unsigned short port;
} ip_endpoint_t;

typedef struct st_esc_node_endpoints {
    ip_endpoint_t tcp_endpoint;
    ip_endpoint_t secure_tcp_endpoint;
} esc_node_endpoints_t;

typedef esc_node_endpoints_t* (*esc_endpoint_discoverer_t)(const void* discover_data, const ip_endpoint_t* failed_tcp_endpoint);

struct st_esc_static_endpoint_discoverer {
    ip_endpoint_t tcp_endpoint;
    bool_t use_ssl_connection;
};
typedef struct st_esc_static_endpoint_discoverer esc_static_endpoint_discoverer_t;

const esc_node_endpoints_t* esc_static_discover(const esc_static_endpoint_discoverer_t* discover_data, const ip_endpoint_t* failed_tcp_endpoint);

#endif //ESC_ESC_ENDPOINT_DISCOVERER_H
